if($DamageType::ZombieAttack $= "")
	AddDamageType("ZombieAttack", '%1\'s brains were eaten!', '%2 ate %1\'s brains!', 1, 1);
if($DamageType::ZombieSilent $= "")
	AddDamageType("ZombieAttack", '', '', 1, 1);

package Zombies
{
	function Armor::damage(%data, %this, %proj, %pos, %damage, %type)
	{
		if(%type == $DamageType::ZombieAttack)
		{
			if(isObject(%mount = %this.getObjectMount()))
			{ %mount.damage(%proj, %pos, %damage / 5, %type); return; }
		}
		if(%this.getState() $= "DEAD") %dontUpdate = 1;
		if(%this.isZombie && isObject(%pl = %proj.client.player)) %pl.invisible = 0;
		if(!%this.isZombie || (%type == $DamageType::Suicide || %type == $DamageType::Vehicle || %type == $DamageType::ZombieAttack))
		{
			if(isObject(%this.getControllingClient()) && $Pref::Server::Zombies::SuperPlayers && %this.isZombie) %damage /= 20;
			%box = %this.getWorldBox();
			%mult = 10.6 / (getWord(%box, 5) - getWord(%box, 2));
			if(!%this.isZombie && %type == $DamageType::ZombieAttack && %this.getDamageLevel() + %damage * %mult >= 100)
			{
				%this.MakeZombie();
				%this.client.chatMessage("\c6You are now a Zombie.");
				%this.client.centerPrint("<color:FFFFFF>Jet to eat braaaaiiiinssss.", 5);
				messageAll('', "\c0Zombie ate "@%this.client.name@"'s brains!");
			}
			Parent::damage(%data, %this, %proj, %pos, %damage, %type);
			if(%this.isZombie && isObject(%team = %this.zombTeam) && %this.getState() $= "DEAD" && !%dontUpdate)
			{
				%team.zombies--;
				ZombieGroup.remove(%this);
				if(%team.zombies <= 0)
				{
					ZombieGroup.colors = ZombieGroup.colors TAB %team.color;
					%s = mCeil(vectorDist(%team.startTime, $Sim::Time));
					%h=mFloor(%s/3600);%s-=%h*3600;%m=mFloor(%s/60);%s-=%m*60;
					if(%h != 0) %msg = %h@":"@(strLen(%m)==1?"0":"")@%m@":"@(strLen(%s)==1?"0":"")@%s;
					else if(%m != 0) %msg = %m@":"@(strLen(%s)==1?"0":"")@%s; else %msg = %s@" second"@(%s==1?"":"s");
					//messageAll('MsgAdminForce', ZombieFactionName(%team.color)@" faction\c6 has been destroyed (lasted for "@%msg@")!");
					%team.delete();
				}
			}
		}
	}
	
	function Armor::onCollision(%data, %this, %col, %pos, %speed)
	{
		if(%this.isZombie && (%col.getType() & $Typemasks::ItemObjectType)) return;
		Parent::onCollision(%data, %this, %col, %pos, %speed);
	}
	
	function Armor::onTrigger(%data, %this, %trig, %tog)
	{
		%this.trigger[%trig] = %tog;
		if(isObject(%cl = %this.getControllingClient()) && %this.isZombie && %trig == 4)
			if(%tog) %this.PlayerSmashLoop(); else cancel(%this.PlayerSmashLoop);
		else if(%this.isZombie) return;
		else Parent::onTrigger(%data, %this, %trig, %tog);
	}
	
	function AkimboGunProjectile::onCollision(%data, %proj, %hit, %fade, %pos, %normal)
	{
		if(%hit.isZombie)
		{
			%nodes = getHitbox(%proj, %hit, %pos);
			if(matchBodyArea(%nodes, $HeadTest) || %hit.isCrouched())
			{ %hit.kill(); if(isObject(%cl = %proj.client)) %cl.score++; }
			else if(matchBodyArea(%nodes, $ChestTest))
			{
				%normal = vectorNormalize(%proj.initialVelocity);
				%shove = vectorNormalize(vectorAdd(%normal, "0 0 0.25"));
				%hit.addVelocity(vectorScale(%shove, 20));
			}
		}
		Parent::onCollision(%data, %proj, %hit, %fade, %pos, %normal);
	}
	
	function GunProjectile::onCollision(%data, %proj, %hit, %fade, %pos, %normal)
	{
		if(%hit.isZombie)
		{
			%nodes = getHitbox(%proj, %hit, %pos);
			if(matchBodyArea(%nodes, $HeadTest) || %hit.isCrouched())
			{
				%hit.kill();
				if(isObject(%cl = %proj.client))
				{
					//%cl.score++;
					%cl.ReloadGunShotsEffective++;
					if(isObject(%hit.client))
						%cl.ReloadGunShotsEffective += mClampF(%cl.ReloadGunShotsMissStreak, 0, 9);
					%cl.score = mFloor(%cl.ReloadGunShotsEffective / %cl.ReloadGunShotsFired * 1000);
					%cl.ReloadGunShotsMissStreak = 0;
				}
			}
			else if(matchBodyArea(%nodes, $ChestTest))
			{
				%cl.ReloadGunShotsEffective += 0.5;
				%cl.ReloadGunShotsMissStreak += 0.5;
				%normal = vectorNormalize(%proj.initialVelocity);
				%shove = vectorNormalize(vectorAdd(%normal, "0 0 0.25"));
				%hit.addVelocity(vectorScale(%shove, 20));
			}
		}
		else if(isObject(%cl = %proj.client))
		{
			if(%hit.getType() & $Typemasks::PlayerObjectType)
			{
				%cl.ReloadGunShotsEffective++;
				if(isObject(%hit.client))
					%cl.ReloadGunShotsEffective += mClampF(%cl.ReloadGunShotsMissStreak, 0, 4);
					%cl.ReloadGunShotsMissStreak = 0;
			}
			else %cl.ReloadGunShotsMissStreak++;
		}
		Parent::onCollision(%data, %proj, %hit, %fade, %pos, %normal);
	}
	
	function GameConnection::createPlayer(%cl, %trans)
	{
		Parent::createPlayer(%cl, %trans);
		if(isObject(%pl = %cl.player))
			%pl.zombiePowerLoop(getSimTime());
	}
	
	function GameConnection::onDeath(%cl, %col, %killer, %damageType, %damageArea)
	{
		if(isObject(%pl = %cl.player) && %pl.isZombie)
			%damageType = $DamageType::ZombieSilent;
		Parent::onDeath(%cl, %col, %killer, %damageType, %damageArea);
	}
	
	function Player::playThread(%pl, %slot, %thread)
	{
		if(%pl.isZombie && %slot == 1 && %thread !$= "ArmReadyBoth") return;
		Parent::playThread(%pl, %slot, %thread);
	}
	
	function Player::delete(%pl)
	{
		if(ZombieGroup.isMember(%pl))
		{
			if(!isObject(%team = %pl.zombTeam))
			{ Parent::delete(%pl); return; }
			%team.zombies--;
			if(%team.zombies <= 0)
			{
				ZombieGroup.colors = ZombieGroup.colors TAB %team.color;
				%s = mCeil(vectorDist(%team.startTime, $Sim::Time));
				%h=mFloor(%s/3600);%s-=%h*3600;%m=mFloor(%s/60);%s-=%m*60;
				if(%h != 0) %msg = %h@":"@(strLen(%m)==1?"0":"")@%m@":"@(strLen(%s)==1?"0":"")@%s;
				else if(%m != 0) %msg = %m@":"@(strLen(%s)==1?"0":"")@%s; else %msg = %s@" second"@(%s==1?"":"s");
				//messageAll('MsgAdminForce', ZombieFactionName(%team.color)@" faction\c6 has been destroyed (lasted for "@%msg@")!");
				%team.delete();
			}
		}
		Parent::delete(%pl);
	}
	
	function servercmdSuicide(%cl)
	{
		if(isObject(%pl = %cl.player) && %pl.isZombie)
			%cl.chatMessage("\c6Zombies can't kill themselves!");
		else	Parent::servercmdSuicide(%cl);
	}
	
	function GameConnection::applyBodyColors(%cl)
	{
		Parent::applyBodyColors(%cl);
		if(isObject(%pl = %cl.player) && %pl.isZombie) %pl.useZombieAvatar();
	}
	
	function GameConnection::applyBodyParts(%cl)
	{
		Parent::applyBodyParts(%cl);
		if(isObject(%pl = %cl.player) && %pl.isZombie) %pl.useZombieAvatar();
	}
};
activatePackage("Zombies");

function Player::PlayerSmashLoop(%this)
{
	cancel(%this.PlayerSmashLoop);
	if(%this.getState() $= "DEAD") return;
	if(vectorDist(%this.lastSmash, %smash = getSimTime()) >= 1500)
	{
		%eye = %this.getEyeVector();
		%pos = %this.getEyePoint();
		%mask = $Typemasks::fxBrickObjectType | $Typemasks::PlayerObjectType | $Typemasks::TerrainObjectType | $Typemasks::VehicleObjectType;
		if(isObject(%target = containerRaycast(%pos, vectorAdd(%pos, vectorScale(%eye, 4)), %mask, %this)))
		{
			if((%target.getType() & $Typemasks::PlayerObjectType) && (!%target.isZombie || (isObject(%this.zombTeam) && isObject(%target.zombTeam) && %target.zombTeam != %this.zombTeam)))
			{
				%this.lastSmash = %smash;
				%this.playThread(2, "activate2");
				%shove = vectorNormalize(vectorAdd(%eye, "0 0 0.5"));
				%target.addVelocity(vectorScale(%shove, 10));
				%target.damage(%this, %this.getHackPosition(), 30, $DamageType::ZombieAttack);
			}
			else if((%target.getType() & $Typemasks::fxBrickObjectType) && %target.stealable)
			{
				%this.lastSmash = %smash;
				%this.playThread(2, "activate2");
				%data = %target.getDatablock();
				if(%target.health $= "")
				{
					if(%data.maxHealth $= "")
						%data.maxHealth = mCeil(%data.brickSizeX * %data.brickSizeY * %data.brickSizeZ / 2);
					%target.health = %data.maxHealth;
				}
				%target.health -= 0.1;
				if(%target.health <= 0) %target.killBrick();
				else for(%i=0;%i<3;%i++) schedule(%i * 500, %this, "serverPlay3D", HammerHitSound, %target.getPosition());
				if(isObject(%cl = %this.client)) %cl.centerPrint("<color:FFFFFF>Breaking "@%data.uiName@": "@getMax(%target.health, 0)@"/"@%data.maxHealth, 3);
			}
			else return;
		}
	}
	%this.PlayerSmashLoop = %this.schedule(48, "PlayerSmashLoop");
}

function Player::zombiePowerLoop(%pl, %last)
{
	if(!isObject(%cl = %pl.client)) return;
	%time = vectorDist(%last, %now = getSimTime()) / 1000;
	if(!%pl.isZombie)
	{
		%divide = 1;
		%divide *= 1 + mClampF(5 - vectorDist(%pl.lastDirectDamageTime, %now) / 6000, 0, 5);
		%pl.healVelocityAmount += vectorLen(%pl.getVelocity()) * %time;
		%pl.healVelocityAmount *= mPow(2.718281828, -0.1 * %time);
		%divide *= 1 + mClampF(%pl.healVelocityAmount / 40, 0, 3);
		%pl.healLookAngAmount += mAcos(vectorDot(%eye = %pl.getEyeVector(), %pl.lastEyeVector)) * 57.2958 * %time;
		%pl.healLookAngAmount *= mPow(2.718281828, -0.5 * %time);
		%divide *= 1 + mClampF(%pl.healLookAngAmount / 120, 0, 1.5);
		if(%pl.trigger0) { %pl.lastTrigger0Time = %now; %divide *= 4; }
		else %divide *= 1 + mClampF(3 - vectorDist(%pl.lastTrigger0Time, %now) / 5000, 0, 3);
		%pl.setDamageLevel(%pl.getDamageLevel() - %time * 5 / %divide);
		if(%pl.getDamageLevel() != %pl.lastDamageLevel)
		{
			%pl.lastDamageLevel = %pl.getDamageLevel();
			commandToClient(%cl, 'setVignette', 0, "1 0 0 "@%pl.getDamagePercent());
		}
	}
	else if(%pl.lastDamageLevel !$= "")
	{
		%pl.lastDamageLevel = "";
			commandToClient(%cl, 'setVignette', 0, "1 0 0 0");
	}
	cancel(%pl.ZombiePowerLoop);
	if(isObject(%teams = ZombieTeams))
	{
		%count = %teams.getCount();
		%unaligned = ZombieGroup.getCount();
		for(%i=0;%i<%count;%i++)
		{
			%team = %teams.getObject(%i);
			%msg = %msg@ZombieFactionTag(%team.color);
			for(%j=0;%j<%team.zombies;%j++)
			{ %msg = %msg@"_"; %unaligned--; }
		}
		%msg = %msg@(%unaligned!=0?"<color:C0C0C0>":"");
		for(%i=0;%i<%unaligned;%i++)
			%msg = %msg@"_";
		if(isObject(%img = %pl.getMountedImage(0)) && isObject(ReloadingGunImage) && %img.getID() == ReloadingGunImage.getID())
			%msg = %msg@"     <color:FFFF00>Ammo: \c6"@%pl.loadedRGunAmmo@" / "@%cl.maxRGunAmmo;
		if(%msg !$= %cl.lastZombieMsg)
		{
			%cl.lastZombieMsg = %msg;
			%cl.bottomPrint(%msg, -1);
		}
	}
	%pl.ZombiePowerLoop = %pl.schedule(48, "zombiePowerLoop", %now);
}

function ZombieFactionName(%color)
{
	%tag = ZombieFactionTag(%color);
	switch$(%color)
	{
		case "0 0 0": return "\c6The "@%tag@"Black";
		case "0 0 1": return "\c6The "@%tag@"Dark Blue";
		case "0 0 2": return "\c6The "@%tag@"Blue";
		case "0 2 0": return "\c6The "@%tag@"Green";
		case "1 0 0": return "\c6The "@%tag@"Dark Red";
		case "1 0 1": return "\c6The "@%tag@"Purple";
	//	case "1 0 2": return "\c6The "@%tag@"Demonite or Bust";
		case "1 1 1": return "\c6The "@%tag@"Gray";
		case "2 0 0": return "\c6The "@%tag@"Red";
		case "2 1 0": return "\c6The "@%tag@"Orange";
		case "2 2 0": return "\c6The "@%tag@"Yellow";
		case "2 2 2": return "\c6The "@%tag@"White";
		default: return "\c6A "@%tag@"Zombie";
	}
}

function ZombieFactionTag(%color)
{
	%tag = "<color:";
	for(%i=0;%i<getWordCount(%color);%i++)
	{
		%bit = getWord(%color, %i);
		switch(%bit)
		{
			case 0: %tag = %tag @ "00";
			case 1: %tag = %tag @ "80";
			case 2: %tag = %tag @ "FF";
		}
	}
	%tag = %tag @ ">";
	return %tag;
}

function servercmdSpawnZombies(%cl)
{ if(%cl.isSuperAdmin) SpawnSingleLoop(); }

datablock fxDtsBrickData(brickZombieSpawnData : brickSpawnPointData)
{ uiName = "Zombie Spawnpoint"; };

function brickZombieSpawnData::onAdd(%data, %brick)
{
	if(!isObject(ZombieSpawnPoints))
		new SimSet(ZombieSpawnPoints);
	if(%brick.isPlanted())
		ZombieSpawnPoints.add(%brick);
}

if($Pref::Server::Zombies::MaxZombies $= "")
	$Pref::Server::Zombies::MaxZombies = 60;

exec("./Hitboxes.cs");
exec("./Zombie AI.cs");