function SpawnZombie(%trans)
{
	if(!isObject(ZombieGroup))
	{
		new SimGroup(ZombieGroup)
		{
			colors = "0 0 0\t0 0 1\t0 0 2\t0 1 0\t0 1 1\t0 1 2\t0 2 0\t0 2 1\t0 2 2\t"@
				 "1 0 0\t1 0 1\t1 0 2\t1 1 0\t1 1 1\t1 1 2\t1 2 0\t1 2 1\t1 2 2\t"@
				 "2 0 0\t2 0 1\t2 0 2\t2 1 0\t2 1 1\t2 1 2\t2 2 0\t2 2 1\t2 2 2";
		};
	}
	if(!isObject(ZombieTeams)) new SimGroup(ZombieTeams);
	if(!isObject(ZombieGroup) || !isObject(ZombieTeams)) return;
	%bot = new AIPlayer()
	{
		datablock = PlayerStandardArmor;
		
		client = %cl;
		isZombie = 1;
		zombTeam = 0;
	};
	%bot.setNodeColor("chest",	"0.8 0.8 0.8 1.0");
	%bot.setNodeColor("headskin",	"0.1 0.6 0.3 1.0");
	%bot.setNodeColor("larm",	"0.8 0.8 0.8 1.0");
	%bot.setNodeColor("lhand",	"0.1 0.6 0.3 1.0");
	%bot.setNodeColor("lshoe",	"0.1 0.6 0.3 1.0");
	%bot.setNodeColor("pants",	"0.4 0.4 0.4 1.0");
	%bot.setNodeColor("rarm",	"0.8 0.8 0.8 1.0");
	%bot.setNodeColor("rhand",	"0.1 0.6 0.3 1.0");
	%bot.setNodeColor("rshoe",	"0.1 0.6 0.3 1.0");
	%bot.playThread(1, "ArmReadyBoth"); ZombieGroup.add(%bot);
	if(isObject(ZombieSpawnPoints) && ZombieSpawnPoints.getCount() != 0)
		%trans = ZombieSpawnPoints.getObject(getRandom(0, ZombieSpawnPoints.getCount() - 1)).getSpawnPoint();
	%bot.setTransform(%trans); %bot.ZombieAI(); return %bot;
}

function AIPlayer::ZombieAI(%bot)
{
	if(!isObject(%bot) || %bot.getState() $= "DEAD")
		return;
	cancel(%bot.AILoop);
	%mask = $Typemasks::fxBrickObjectType | $Typemasks::TerrainObjectType;
	%group = ZombieGroup; %count = %group.getCount();
	if($Pref::Server::Zombies::ZombieTeams)
	{
		for(%i=0;%i<%count;%i++)
		{
			%this = %group.getObject(%i);
			if(%bot == %this) continue;
			if(%this.invisible) continue;
			if(%this.getState() $= "DEAD") continue;
			if(isObject(containerRaycast(%bot.getEyePoint(), %this.getEyePoint(), %mask, %bot, %this))
				&& isObject(containerRaycast(%bot.getEyePoint(), %this.getPosition(), %mask, %bot, %this))) continue;
			if(!isObject(%bot.zombTeam) || !isObject(%this.zombTeam))
			{
				if(isObject(%team = %this.zombTeam) && (ZombieGroup.getCount() > 20 && %team.zombies >= ZombieGroup.getCount() / 2 && !$Pref::Server::Zombies::SuperPlayers))
					continue;
				%friend[-1+%friends++] = %this;
			}
			else if(isObject(%bot.zombTeam) && %this.zombTeam != %bot.zombTeam && !isObject(containerRaycast(%bot.getEyePoint(), %this.getHackPosition(), %mask, %bot, %this)))
				%enemy[-1+%enemies++] = %this;
		}
	}
	initContainerRadiusSearch(%bot.getHackPosition(), 80, $Typemasks::PlayerObjectType);
	while(isObject(%this = containerSearchNext()))
		if(!ZombieGroup.isMember(%this) && !%this.invisible)
		{
			if(!(isObject(containerRaycast(%bot.getEyePoint(), %this.getEyePoint(), %mask, %bot, %this))
				&& isObject(containerRaycast(%bot.getEyePoint(), %this.getPosition(), %mask, %bot, %this))))
			{
				%enemy[-1+%enemies++] = %this;
				%team = %this.zombTeam;
				if(!isObject(%onlyTarget) && (ZombieGroup.getCount() > 20 && %team.zombies >= ZombieGroup.getCount() / 3 && !$Pref::Server::Zombies::SuperPlayers))
					%onlyTarget = %team;
			}
		}
	if(isObject(%onlyTarget))
	{
		for(%i=0;%i<%enemies;%i++)
			if(%enemy[%i].zombTeam == %onlyTarget)
				%enemy[%i - %shift] = %enemy[%i];
			else	%shift++;
		%enemies -= %shift;
	}
	if(%enemies != 0)
	{
		%pos = %bot.getHackPosition();
		for(%i=0;%i<%enemies;%i++)
		{
			%dist = vectorDist(%pos, %enemy[%i].getHackPosition());
			if(%dist < %closest || %closest $= "")
			{ %closest = %dist; %target = %enemy[%i]; }
		}
		if(isObject(%target))
		{
			%targetting = 1;
			%bot.setAimObject(%target);
			%bot.setMoveY(10);
			%bot.setMoveX(0);
			if(%targetting && isObject(firstWord(containerRaycast(%bot.getPosition(), %target.getEyePoint(), %mask, %bot, %target))))
				%jump = 1;
			if(%targetting && (isObject(firstWord(containerRaycast(%bot.getEyePoint(), %target.getEyePoint(), %mask, %bot, %target)))
				|| isObject(firstWord(containerRaycast(%bot.getHackPosition(), %target.getEyePoint(), %mask, %bot, %target)))))
				%crouch = 1;
		}
	}
	if($Pref::Server::Zombies::ZombieTeams && %friends != 0)
	{
		%pos = %bot.getHackPosition();
		for(%i=0;%i<%friends;%i++)
		{
			%this = %friend[%i]; %dist = vectorDist(%pos, %this.getHackPosition());
			if(%dist <= 8)
			{
				if(isObject(%this.zombTeam) && !isObject(%bot.zombTeam) && !(ZombieGroup.getCount() > 20 && %this.zombTeam.zombies >= ZombieGroup.getCount() * (2 / 3) && !$Pref::Server::Zombies::SuperPlayers))
				{
					%bot.zombTeam = %this.zombTeam; %bot.zombTeam.zombies++;
					%bot.setNodeColor("chest", vectorScale(%bot.zombTeam.color, 0.5) SPC 1);
					%bot.setNodeColor("larm", vectorScale(%bot.zombTeam.color, 0.5) SPC 1);
					%bot.setNodeColor("pants", vectorScale(%bot.zombTeam.color, 0.25) SPC 1);
					%bot.setNodeColor("rarm", vectorScale(%bot.zombTeam.color, 0.5) SPC 1);
				}
				else if(!isObject(%this.zombTeam))
					%buddies++;
			}
			if(!%targetting && ((%dist < %closest && %dist > 6.5) || %closest $= ""))
			{ %closest = %dist; %target = %this; }
		}
		if($Pref::Server::Zombies::ZombieTeams && %buddies >= 4 && !isObject(%bot.zombTeam) && getFieldCount(%colors = ZombieGroup.colors) != 0)
		{
			%color = getRandom(0, getFieldCount(%colors) - 1);
			ZombieTeams.add(%zombTeam = new SimObject() { color = getField(%colors, %color); startTime = $Sim::Time; });
			%colors = removeField(%colors, %color);
			ZombieGroup.colors = %colors;
			%bot.zombTeam = %zombTeam; %bot.zombTeam.zombies++;
			%bot.setNodeColor("chest", vectorScale(%bot.zombTeam.color, 0.5) SPC 1);
			%bot.setNodeColor("larm", vectorScale(%bot.zombTeam.color, 0.5) SPC 1);
			%bot.setNodeColor("pants", vectorScale(%bot.zombTeam.color, 0.25) SPC 1);
			%bot.setNodeColor("rarm", vectorScale(%bot.zombTeam.color, 0.5) SPC 1);
			//messageAll('MsgAdminForce', ZombieFactionName(%zombTeam.color)@" faction\c6 has been formed!");
		}
		else if(!%targetting || %closest > 12)
		{
			%cBrick = 999999;
			initContainerRadiusSearch(%bot.getHackPosition(), 4, $Typemasks::fxBrickObjectType);
			while(isObject(%brick = containerSearchNext()))
				if(%brick.stealable)
				{
					if(%brick.getNumDownBricks() == 1)
						if(%brick.getDownBrick(0).getDatablock().getID() == brickStealableSpawnData.getID())
							continue;
					%bPos = %brick.getPosition();
					%dist = vectorDist(%bot.getHackPosition(), %bPos);
					if(%dist >= %cBrick) continue;
					if(!isObject(containerRaycast(%bot.getEyePoint(), %brick.getPosition(), %mask, %bot, %brick)))
					{ %cBrick = %dist; %attack = %brick; }
				}
			if(isObject(%attack))
			{
				%bot.setAimLocation(%attack.getPosition());
				%bot.setMoveY(vectorDist(setWord(%bot.getPosition(), 2, 0), setWord(%attack.getPosition(), 2, 0)) / 3);
				%bot.setMoveX(0);
				%eye = %bot.getEyePoint();
				%dir = %bot.getEyeVector();
				if(vectorDot(%dir, vectorNormalize(vectorSub(%attack.getPosition(), %bot.getHackPosition()))) >= 0.8
					&& vectorDist(%bot.lastSmash, %smash = getSimTime()) >= 1500)
				{
					%bot.playThread(2, "activate2");
					%data = %attack.getDatablock();
					if(%attack.health $= "")
					{
						if(%data.maxHealth $= "")
							%data.maxHealth = mCeil(%data.brickSizeX * %data.brickSizeY * %data.brickSizeZ / 2);
						%attack.health = %data.maxHealth;
					}
					%attack.health -= 0.1;
					if(%attack.health <= 0) %attack.killBrick();
					else for(%i=0;%i<3;%i++) schedule(%i * 500, %bot, "serverPlay3D", HammerHitSound, %attack.getPosition());
					%bot.lastSmash = %smash;
				}
			}
			else if(isObject(%target))
			{
				%bot.setAimObject(%target);
				%bot.setMoveY(10);
				%bot.setMoveX(0);
				if(%targetting && isObject(firstWord(containerRaycast(%bot.getPosition(), %target.getEyePoint(), %mask, %bot, %target))))
					%jump = 1;
				if(%targetting && (isObject(firstWord(containerRaycast(%bot.getEyePoint(), %target.getEyePoint(), %mask, %bot, %target)))
					|| isObject(firstWord(containerRaycast(%bot.getHackPosition(), %target.getEyePoint(), %mask, %bot, %target)))))
					%crouch = 1;
			}
		}
		else if(isObject(%target))
		{
			%bot.setAimObject(%target);
			%bot.setMoveY(10);
			%bot.setMoveX(0);
			if(%targetting && isObject(firstWord(containerRaycast(%bot.getPosition(), %target.getEyePoint(), %mask, %bot, %target))))
				%jump = 1;
			if(%targetting && (isObject(firstWord(containerRaycast(%bot.getEyePoint(), %target.getEyePoint(), %mask, %bot, %target)))
				|| isObject(firstWord(containerRaycast(%bot.getHackPosition(), %target.getEyePoint(), %mask, %bot, %target)))))
				%crouch = 1;
		}
	}
	if(isObject(%target) && %targetting && %closest <= 4)
	{
		if(vectorDot(%eye = %bot.getEyeVector(), vectorNormalize(vectorSub(%target.getHackPosition(), %bot.getHackPosition()))) >= 0.8)
		{
			if(vectorDist(%bot.lastSmash, %smash = getSimTime()) >= 1500)
			{
				%bot.playThread(2, "activate2");
				%shove = vectorNormalize(vectorAdd(%eye, "0 0 0.5"));
				%target.addVelocity(vectorScale(%shove, 10));
				%target.damage(%bot, %bot.getHackPosition(), 30, $DamageType::ZombieAttack);
				%bot.lastSmash = %smash;
			}
		}
	}
	if(%enemies + %friends == 0)
	{
		%closest = 999999;
		initContainerRadiusSearch(%bot.getHackPosition(), 12, $Typemasks::fxBrickObjectType);
		while(isObject(%brick = containerSearchNext()))
			if(%brick.stealable)
			{
				if(%brick.getNumDownBricks() == 1)
					if(%brick.getDownBrick(0).getDatablock().getID() == brickStealableSpawnData.getID())
						continue;
				%pos = %brick.getPosition();
				%dist = vectorDist(%bot.getHackPosition(), %pos);
				if(%dist >= %closest) continue;
				if(!isObject(containerRaycast(%bot.getEyePoint(), %brick.getPosition(), %mask, %bot, %brick)))
				{ %closest = %dist; %attack = %brick; }
			}
		if(isObject(%attack) && %closest <= 4)
		{
			%bot.setAimLocation(%attack.getPosition());
			%bot.setMoveY(vectorDist(setWord(%bot.getPosition(), 2, 0), setWord(%attack.getPosition(), 2, 0)) / 3);
			%bot.setMoveX(0);
			%eye = %bot.getEyePoint();
			%dir = %bot.getEyeVector();
			if(vectorDot(%dir, vectorNormalize(vectorSub(%attack.getPosition(), %bot.getHackPosition()))) >= 0.8
				&& vectorDist(%bot.lastSmash, %smash = getSimTime()) >= 1500)
			{
				%bot.playThread(2, "activate2");
				%data = %attack.getDatablock();
				if(%attack.health $= "")
				{
					if(%data.maxHealth $= "")
						%data.maxHealth = mCeil(%data.brickSizeX * %data.brickSizeY * %data.brickSizeZ / 2);
					%attack.health = %data.maxHealth;
				}
				%attack.health -= 0.1;
				if(%attack.health <= 0) %attack.killBrick();
				else for(%i=0;%i<3;%i++) schedule(%i * 500, %bot, "serverPlay3D", HammerHitSound, %attack.getPosition());
				%bot.lastSmash = %smash;
			}
		}
		else
		{
			if(vectorDist(%bot.lastWanderTime, getSimTime()) > %bot.lastWanderDuration)
			{
				%bot.lastWanderTime = getSimTime();
				%bot.lastWanderDuration = 3000 + getRandom(0, 1500);
				%ang = getRandom() * 6.28319;
				%bot.wanderGoal = mSin(%ang) SPC mCos(%ang);
			}
			%bot.setAimLocation(vectorAdd(%bot.getEyePoint(), vectorScale(%bot.wanderGoal, 1000)));
			%bot.setMoveY(10);
			%bot.setMoveX(0);
		}
	}
	%bot.setJumping(%jump);
	%bot.setCrouching(%crouch);
	%bot.AILoop = %bot.schedule(16, "ZombieAI");
}

function Player::ZombieLoop(%pl)
{
	if(!isObject(%pl) || %pl.getState() $= "DEAD")
		return;
	cancel(%pl.ZombieLoop);
	if($Pref::Server::Zombies::ZombieTeams)
	{
		%group = ZombieGroup; %count = %group.getCount();
		for(%i=0;%i<%count;%i++)
		{
			%this = %group.getObject(%i);
			if(%pl == %this) continue;
			if(%this.invisible) continue;
			if(%this.getState() $= "DEAD") continue;
			if(!isObject(%pl.zombTeam) || !isObject(%this.zombTeam))
			{
				if(isObject(%team = %this.zombTeam) && (ZombieGroup.getCount() > 20 && %team.zombies >= ZombieGroup.getCount() / 2 && !$Pref::Server::Zombies::SuperPlayers))
					continue;
				%friend[-1+%friends++] = %this;
			}
		}
		if(%friends != 0)
		{
			%pos = %pl.getHackPosition();
			for(%i=0;%i<%friends;%i++)
			{
				%this = %friend[%i]; %dist = vectorDist(%pos, %this.getHackPosition());
				if(%dist <= 8)
				{
					if(isObject(%this.zombTeam) && !isObject(%pl.zombTeam) && !(ZombieGroup.getCount() > 20 && %this.zombTeam.zombies >= ZombieGroup.getCount() * (2 / 3) && !$Pref::Server::Zombies::SuperPlayers))
					{
						%pl.zombTeam = %this.zombTeam; %pl.zombTeam.zombies++;
						%pl.setNodeColor("chest", vectorScale(%pl.zombTeam.color, 0.5) SPC 1);
						%pl.setNodeColor("larm", vectorScale(%pl.zombTeam.color, 0.5) SPC 1);
						%pl.setNodeColor("pants", vectorScale(%pl.zombTeam.color, 0.25) SPC 1);
						%pl.setNodeColor("rarm", vectorScale(%pl.zombTeam.color, 0.5) SPC 1);
					}
					else if(!isObject(%this.zombTeam))
						%buddies++;
				}
			}
			if(%buddies >= 4 && !isObject(%pl.zombTeam) && getFieldCount(%colors = ZombieGroup.colors) != 0)
			{
				%color = getRandom(0, getFieldCount(%colors) - 1);
				ZombieTeams.add(%zombTeam = new SimObject() { color = getField(%colors, %color); startTime = $Sim::Time; });
				%colors = removeField(%colors, %color);
				ZombieGroup.colors = %colors;
				%pl.zombTeam = %zombTeam; %pl.zombTeam.zombies++;
				%pl.setNodeColor("chest", vectorScale(%pl.zombTeam.color, 0.5) SPC 1);
				%pl.setNodeColor("larm", vectorScale(%pl.zombTeam.color, 0.5) SPC 1);
				%pl.setNodeColor("pants", vectorScale(%pl.zombTeam.color, 0.25) SPC 1);
				%pl.setNodeColor("rarm", vectorScale(%pl.zombTeam.color, 0.5) SPC 1);
				//messageAll('MsgAdminForce', ZombieFactionName(%zombTeam.color)@" faction\c6 has been formed!");
			}
		}
	}
	%pl.ZombieLoop = %pl.schedule(16, "ZombieLoop");
}

function Player::MakeZombie(%pl)
{
	%pl.playThread(1, "ArmReadyBoth"); %pl.setDatablock(PlayerNoJet);
	%pl.setHealth(10000); %pl.clearTools(); %pl.hideNode("ALL"); %pl.useZombieAvatar();
	%pl.setShapeNameDistance(0); %pl.isZombie = 1; ZombieGroup.add(%pl); %pl.ZombieLoop();
}

function Player::useZombieAvatar(%pl)
{
	%pl.hideNode("larmslim");	%pl.hideNode("rarmslim");
	%pl.hideNode("lpeg");		%pl.hideNode("rpeg");
	%pl.unhideNode("chest");	%pl.setNodeColor("chest",	"0.8 0.8 0.8 1.0");
	%pl.unhideNode("headskin");	%pl.setNodeColor("headskin",	"0.1 0.6 0.3 1.0");
	%pl.unhideNode("larm");		%pl.setNodeColor("larm",	"0.8 0.8 0.8 1.0");
	%pl.unhideNode("lhand");	%pl.setNodeColor("lhand",	"0.1 0.6 0.3 1.0");
	%pl.unhideNode("lshoe");	%pl.setNodeColor("lshoe",	"0.1 0.6 0.3 1.0");
	%pl.unhideNode("pants");	%pl.setNodeColor("pants",	"0.4 0.4 0.4 1.0");
	%pl.unhideNode("rarm");		%pl.setNodeColor("rarm",	"0.8 0.8 0.8 1.0");
	%pl.unhideNode("rhand");	%pl.setNodeColor("rhand",	"0.1 0.6 0.3 1.0");
	%pl.unhideNode("rshoe");	%pl.setNodeColor("rshoe",	"0.1 0.6 0.3 1.0");
	if(isObject(%pl.zombTeam))
	{
		%pl.setNodeColor("chest", vectorScale(%pl.zombTeam.color, 0.5) SPC 1);
		%pl.setNodeColor("larm", vectorScale(%pl.zombTeam.color, 0.5) SPC 1);
		%pl.setNodeColor("pants", vectorScale(%pl.zombTeam.color, 0.25) SPC 1);
		%pl.setNodeColor("rarm", vectorScale(%pl.zombTeam.color, 0.5) SPC 1);
	}
}



//Various testing functions
function SpawnSingleLoop(){cancel($SpawnerLoop);if(!isObject(ZombieGroup) || ZombieGroup.getCount() < $Pref::Server::Zombies::MaxZombies)SpawnSingle();$SpawnerLoop = schedule(5000, 0, "SpawnSingleLoop");}
function SpawnSingle(){SpawnZombie(getRandom(-100, 100) SPC getRandom(-100, 100) @ " 0 1 0 0 0");}
function SpawnGroup(%pos){for(%i=0;%i<20;%i++)SpawnZombie(getRandom(-12, 12) + getWord(%pos, 0) SPC getRandom(-12, 12) + getWord(%pos, 1) @ " 0 1 0 0 0");}
function SpawnHorde(){for(%i=0;%i<50;%i++)SpawnZombie(getRandom(-100, 100) SPC getRandom(-100, 100) @ " 0 1 0 0 0");}